SystemOrganization addCategory: #ProxiesTests!

!CompiledMethodProxySwapperHandler classSide methodsFor: '*ProxiesTests' stamp: 'MarianoMartinezPeck 4/1/2011 16:08'!
forTestingUninstallForProxy: aProxy compiledMethod: aMethod
	| oldMethod |
	aProxy mareaIsProxyInstalled ifFalse: [^ nil].
	oldMethod := aMethod.
	self mareaLog: 'The CompiledMethod ', oldMethod mareaPrintString, ' was loaded form file.'.
	oldMethod methodClass  methodDict at: (oldMethod selector) put: oldMethod.
	self mareaLog: 'The Proxy for ', oldMethod mareaPrintString, ' was uninstalled.'.
	self removeFile: aProxy mareaFileName.
	aProxy mareaMarkAsUninstalled.
	^ oldMethod.  
! !

!ProtoObject methodsFor: '*ProxiesTests' stamp: 'MarianoMartinezPeck 11/30/2010 15:43'!
size
	^ -1! !

!MareaSerializer methodsFor: '*ProxiesTests' stamp: 'MarianoMartinezPeck 11/24/2010 23:29'!
internalMethodForTesting
	^ self shouldBeImplemented ! !

TestCase subclass: #AbstractCompiledMethodProxyTest
	instanceVariableNames: 'proxyClass proxyInstance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 12/13/2010 20:15'!
crashTestCompiledMethodProxy2
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: PseudoContext  selector: #isPseudoContext.
	[self assert: (PseudoContext methodDict mareaAt: #isPseudoContext) class name equals:  self proxyClassName.
	aProxy zaraza.
	self assert: (PseudoContext methodDict mareaAt: #isPseudoContext) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'helper' stamp: 'MarianoMartinezPeck 11/20/2010 18:21'!
installCompiledMethodProxyOn: aClass selector: aSelector
	^ self proxyClass installOn: aClass selector: aSelector.! !

!AbstractCompiledMethodProxyTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 11/30/2010 17:24'!
proxyClass
	^ proxyClass
	

! !

!AbstractCompiledMethodProxyTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 11/30/2010 17:25'!
proxyClassInstance
	^ proxyInstance
	

! !

!AbstractCompiledMethodProxyTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 11/20/2010 18:11'!
proxyClassName
	^ self proxyClass name! !

!AbstractCompiledMethodProxyTest methodsFor: 'running' stamp: 'MarianoMartinezPeck 4/1/2011 16:34'!
setUp
	CompiledMethodProxySwapperHandler serializer: FuelMareaSerializer. 
	FilenameCompiledMethodProxySwapper runningTest: true.
	proxyClass := FilenameCompiledMethodProxySwapper.
	proxyInstance := FilenameCompiledMethodProxySwapper new.
	
	(FileDirectory default fileNamesMatching: '*.swap*') 
		do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'running' stamp: 'MarianoMartinezPeck 11/27/2010 16:48'!
tearDown
	(FileDirectory default fileNamesMatching: '*.swap*') 
		do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodMessageSent
	"A simple CompiledMethodProxy test"
	| aProxy |
	
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  self proxyClassName.
	"Notice that in this case we are not executing the CompiledMethod but instead, sending messages to it.
	In this case, the original method should be back also."
	self assert: (ClassWith1Var methodDict mareaAt: #foo) literals size equals: 3.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].


! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodMessageSentByPerform
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  self proxyClassName.
	"Notice that in this case we are not executing the CompiledMethod but instead, sending messages to it.
	In this case, the original method should be back also."
	self assert: ((ClassWith1Var methodDict mareaAt: #foo) perform: #literals) size equals: 3.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].


! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodMessageSentByPerformWith
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo:.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo:) class name equals:  self proxyClassName.
	"Notice that in this case we are not executing the CompiledMethod but instead, sending messages to it.
	In this case, the original method should be back also."
	self assert: ((ClassWith1Var methodDict mareaAt: #foo:) perform: #literals) size equals: 3.
	self assert: (ClassWith1Var methodDict mareaAt: #foo:) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].


! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodMessageSentByPerformWithNotUnderstood
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  self proxyClassName.
	"Notice that in this case we are not executing the CompiledMethod but instead, sending messages to it.
	In this case, the original method should be back also."
	self should: [(ClassWith1Var methodDict mareaAt: #foo) perform: #nonExistentMethod] raise: Error.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].


! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodMessageSentByPerformWithNotUnderstood2
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  self proxyClassName.
	"Notice that in this case we are not executing the CompiledMethod but instead, sending messages to it.
	In this case, the original method should be back also." 
	self should: [(ClassWith1Var methodDict mareaAt: #foo) perform: #fooDNU] raise: Error.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].


! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:01'!
testCompiledMethodProxy
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  self proxyClassName.
	self assert: (ClassWith1Var new foo = 'foo').
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxyAllInstalledProxiesCount
	"A simple CompiledMethodProxy test"
	| aProxy aProxy2 aProxy3 |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	aProxy2 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo2.
	aProxy3 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo3.
	[self assert: self proxyClass mareaAllInstalledProxiesCount equals: 3.
	"This will automatically uninstall the proxy"
	ClassWith1Var new foo.
	self assert: self proxyClass mareaAllInstalledProxiesCount equals: 2.
	aProxy2 mareaUninstallIfNeeded. 
	self assert: self proxyClass mareaAllInstalledProxiesCount equals: 1.
	] ensure: [ 
		aProxy mareaUninstallIfNeeded.
		aProxy2 mareaUninstallIfNeeded.
		aProxy3 mareaUninstallIfNeeded.].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxyAndGC
	"A simple CompiledMethodProxy test"
	| aProxy methodsInstCountFirst  methodsInstCountEnd proxyCount proxyCountEnd|
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	methodsInstCountFirst := CompiledMethod instanceCount.
	proxyCount := self proxyClass instanceCount.
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  self proxyClassName.
	"This line is important because the MCMethodDefinition have references to the CompiledMethod"
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	methodsInstCountEnd := CompiledMethod instanceCount.
	proxyCountEnd := self proxyClass instanceCount.
	self assert: (methodsInstCountFirst - 1) equals: methodsInstCountEnd.
	(self proxyClass = SmallInteger) ifFalse: [self assert: (proxyCount + 1) equals: proxyCountEnd].
	self assert: (ClassWith1Var new foo = 'foo').
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  #CompiledMethod.
	aProxy := nil.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	methodsInstCountEnd := CompiledMethod instanceCount.
	proxyCountEnd := self proxyClass instanceCount.
	self assert: methodsInstCountFirst equals: methodsInstCountEnd.
	self assert: proxyCount equals: proxyCountEnd.
	] ensure: [
		aProxy isNil ifFalse: [aProxy mareaUninstallIfNeeded].
		MCMethodDefinition shutDown. 
		Smalltalk garbageCollect].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxyAndPerform
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: ((ClassWith1Var methodDict mareaAt: #foo) class name = self proxyClassName).
	self assert: ((ClassWith1Var new perform: #foo) = 'foo').
	self assert: ((ClassWith1Var methodDict mareaAt: #foo) class name = #CompiledMethod).
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxyAndPerformWith
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo:.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo:) class name equals:  self proxyClassName.
	self assert: (ClassWith1Var new perform: #foo: with: 2) equals: 'foo'.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxyAndPerformWithNotUnderstood2
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #fooDNU.
	[self assert: (ClassWith1Var methodDict mareaAt: #fooDNU) class name equals:  self proxyClassName.
	self should: [ClassWith1Var new perform: #fooDNU ] raise: Error. 
	self assert: (ClassWith1Var methodDict mareaAt: #fooDNU) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxyCaseSensitive
	"A simple CompiledMethodProxy test"
	| aProxy aProxy2 |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	aProxy2 := self installCompiledMethodProxyOn: ClassWith1Var selector: #fOO.
	
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: self proxyClassName.
	self assert: (ClassWith1Var methodDict mareaAt: #fOO) class name equals: self proxyClassName.
	self assert: ClassWith1Var new foo equals: 'foo'.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: #CompiledMethod.
	self assert: (ClassWith1Var methodDict mareaAt: #fOO) class name equals: self proxyClassName.
	self assert: (ClassWith1Var new fOO = 'fOO').
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: #CompiledMethod.
	self assert: (ClassWith1Var methodDict mareaAt: #fOO) class name equals: #CompiledMethod.
	] ensure: [ 
		aProxy mareaUninstallIfNeeded.
		aProxy2 mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxyCategory
	"A simple CompiledMethodProxy test"
	| aProxy |
	self assert: (ClassWith1Var >> #foo) category = #accessing.
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: self proxyClassName.
	self assert: ClassWith1Var new foo equals: 'foo'.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: #CompiledMethod.
	self assert: (ClassWith1Var >> #foo) category equals:  #accessing.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxyCategory2
	"A simple CompiledMethodProxy test"
	| aProxy |
	self assert: (ClassWith1Var >> #fooCategory) category equals: #'test - category'.
	self assert: (ClassWith1Var organization listAtCategoryNamed: #'test - category') size equals: 1.
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	self assert: (ClassWith1Var organization listAtCategoryNamed: #'test - category') size equals: 1.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: self proxyClassName.
	self assert: ClassWith1Var new fooCategory equals: 'fooCategory'.
	self assert: (ClassWith1Var methodDict mareaAt: #fooCategory) class name equals: #CompiledMethod.
	self assert: (ClassWith1Var >> #fooCategory) category equals: #'test - category'.
	self assert: (ClassWith1Var organization listAtCategoryNamed: #'test - category') size equals: 1.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxyClassMethod
	"A simple CompiledMethodProxy test"
	| aProxy  aProxyClass|
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	aProxyClass := self proxyClass.
	aProxyClass runningTest: false.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) mareaClass equals: aProxyClass.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class equals: CompiledMethod.
	self assert: ClassWith1Var new foo equals: 'foo'.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/14/2011 16:46'!
testCompiledMethodProxyClassMethodNotTesting
	"A simple CompiledMethodProxy test"
	| aProxy |
	self proxyClass runningTest: false.
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  #CompiledMethod.
	self assert: (ClassWith1Var new foo = 'foo').
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/31/2011 12:58'!
testCompiledMethodProxyDNUMessage
	self should: [self proxyClassInstance perform: #zaraza] raise: MessageNotUnderstood.! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxyDifficult
	"A simple CompiledMethodProxy test"
	| aProxy |
	
	aProxy := self installCompiledMethodProxyOn: TestRunner selector: #addMethodsUnderTestIn:to:.
	[self assert: (TestRunner methodDict mareaAt: #addMethodsUnderTestIn:to:) class name equals: self proxyClassName.
	TestRunner new addMethodsUnderTestIn: (Array with: (PackageInfo named: 'VMMaker')) to: (OrderedCollection with: CompiledMethod toReturnSelf).
	self assert: (TestRunner methodDict mareaAt: #addMethodsUnderTestIn:to:) class name equals: #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxyFlushCache
	"A simple CompiledMethodProxy test"
	| aProxy anObject |
	anObject := ClassWith1Var new. 
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #fooSomething.
	[self assert: (ClassWith1Var methodDict mareaAt: #fooSomething) class name equals: self proxyClassName.
	self assert: anObject fooSomething equals: 'fooSomething'.
	self assert: anObject fooSomething equals: 'fooSomething'.
	self assert: (ClassWith1Var methodDict mareaAt: #fooSomething) class name equals: #CompiledMethod.
	self assert: anObject fooSomething equals: 'fooSomething'.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 4/5/2011 11:46'!
testCompiledMethodProxyIdentifyProblem
	"A simple CompiledMethodProxy test"
	| aProxy method |
	method := ClassWith1Var >>#foo.
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[ self deny: aProxy == method. 
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:10'!
testCompiledMethodProxyInstallTwice
	"A simple CompiledMethodProxy test"
	| aProxy aProxy2 |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	self shouldnt: [aProxy2 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo] raise: Error.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: self proxyClassName.
	self assert: ClassWith1Var new foo equals: 'foo'.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].


! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 4/5/2011 10:37'!
testCompiledMethodProxyInstallingInSuperclassMethodDict
	
	self should: [self installCompiledMethodProxyOn: ClassWith1Var selector: #name] raise: SelectorNotFoundError.! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/31/2011 15:38'!
testCompiledMethodProxySwapDNUMessage
	"A simple CompiledMethodProxy test"
	
	| aProxy |
	
	aProxy := self installCompiledMethodProxyOn: ClassWithDNU selector: #doesNotUnderstand:.
	
	[self assert: (ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) class name equals:  self proxyClassName.
	self assert: (ClassWithDNU new doesNotUnderstand: 'zaraza') equals: 'dnu'.
	self assert: (ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].

	aProxy := self installCompiledMethodProxyOn: ClassWithDNU selector: #doesNotUnderstand:.
	[self assert: (ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) class name equals:  self proxyClassName.
	self assert: (ClassWithDNU new zaraza) equals: 'dnu'.
	self assert: (ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].

	aProxy := self installCompiledMethodProxyOn: ClassWithDNU selector: #doesNotUnderstand:.
	[self assert: (ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) class name equals:  self proxyClassName.
	self should: [(ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) zaraza] raise: MessageNotUnderstood.
	self assert: (ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].

	aProxy := self installCompiledMethodProxyOn: ClassWithDNU selector: #doesNotUnderstand:.
	[self assert: (ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) class name equals:  self proxyClassName.
	self should: [(ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) zaraza] raise: MessageNotUnderstood.
	self assert: (ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].

	aProxy := self installCompiledMethodProxyOn: ClassWithDNU selector: #doesNotUnderstand:.
	[self assert: (ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) class name equals:  self proxyClassName.
	self should: [(ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) doesNotUnderstand: 'aa'] raise: MessageNotUnderstood.
	"The proxy is uninstalled in this case since it doesn't understand #doesNotUnderstand:"
	self assert: (ClassWithDNU methodDict mareaAt: #doesNotUnderstand:) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 4/1/2011 16:08'!
testCompiledMethodProxySwapOutExternalMethodNeededForSwapIn
	"A simple CompiledMethodProxy test"
	| aProxy aProxy2 internalMethodForTesting |
	"For this test it should be necessary to close all windows that are browsing ClassWith1Var or CompiledMethodProxyHandler"
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	internalMethodForTesting := (CompiledMethodProxySwapperHandler serializer internalMethodForTesting) copy.
	aProxy2 := self installCompiledMethodProxyOn: internalMethodForTesting methodClass selector: internalMethodForTesting selector.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: self proxyClassName.
	"Now...if I want to swap in  any method.....I will have a loop"
	self should: [ClassWith1Var new foo = 'foo'] raise: PossibleLoopDetection.
	] ensure: [
		CompiledMethodProxySwapperHandler forTestingUninstallForProxy: aProxy2 compiledMethod: internalMethodForTesting.
		aProxy mareaUninstallIfNeeded.
	].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 4/1/2011 16:08'!
testCompiledMethodProxySwapOutInternalMethodNeededForSwapIn
	"A simple CompiledMethodProxy test"
	| aProxy aProxy2 bkpMethod |
	"For this test it should be necessary to close all windows that are browsing ClassWith1Var or CompiledMethodProxyHandler"
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	bkpMethod := (ObjectProxySwapperHandler class methodDict at: #serializer) copy.
	aProxy2 := self installCompiledMethodProxyOn: ObjectProxySwapperHandler class selector: #serializer.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: self proxyClassName.
	"Now...if I want to swap in  any method.....I will have a loop"
	self should: [ClassWith1Var new foo = 'foo'] raise: PossibleLoopDetection.
	] ensure: [
		CompiledMethodProxySwapperHandler forTestingUninstallForProxy: aProxy2 compiledMethod: bkpMethod.
		aProxy mareaUninstallIfNeeded.
	].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:20'!
testCompiledMethodProxyUnInstall
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: self proxyClassName.
	self assert: aProxy mareaIsProxyInstalled.
	"This will automatically uninstall the proxy"
	self assert: ClassWith1Var new foo equals: 'foo'.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: #CompiledMethod.
	self deny: aProxy mareaIsProxyInstalled.
	] ensure: [ aProxy mareaUninstallIfNeeded].


	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: self proxyClassName.
	self assert: aProxy mareaIsProxyInstalled.
	aProxy mareaUninstall.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: #CompiledMethod.
	self deny: aProxy mareaIsProxyInstalled.
	] ensure: [ aProxy mareaUninstallIfNeeded].! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 12/1/2010 18:07'!
testCompiledMethodProxyUnInstallAllInstances
	"A simple CompiledMethodProxy test"
	| aProxy aProxy2 aProxy3 |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	aProxy2 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo2.
	aProxy3 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo3.
	[self assert: aProxy mareaIsProxyInstalled.
	self assert: aProxy2 mareaIsProxyInstalled.
	self assert: aProxy3 mareaIsProxyInstalled.	
	
	"This will automatically uninstall the proxy"
	self assert: ClassWith1Var new foo equals: 'foo'.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: #CompiledMethod.
	self deny: aProxy mareaIsProxyInstalled.
	self assert: aProxy2 mareaIsProxyInstalled.
	self assert: aProxy3 mareaIsProxyInstalled.	
	
	self proxyClass mareaUninstallIfNeededAllInstances.
	
	self assert: (ClassWith1Var methodDict mareaAt: #foo2) class name equals: #CompiledMethod.
	self deny: aProxy2 mareaIsProxyInstalled.
	self assert: (ClassWith1Var methodDict mareaAt: #foo3) class name equals: #CompiledMethod.
	self deny: aProxy3 mareaIsProxyInstalled.
	
	] ensure: [ 
		aProxy mareaUninstallIfNeeded.
		aProxy2 mareaUninstallIfNeeded.
		aProxy3 mareaUninstallIfNeeded.].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'mariano 11/27/2010 16:22'!
testCompiledMethodProxyUnInstallMultipleTimes
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: self proxyClassName.
	self assert: aProxy mareaIsProxyInstalled.
	aProxy mareaUninstall.
	self should: [aProxy mareaUninstall.] raise: ProxyIsNotInstalled.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals: #CompiledMethod.
	self deny: aProxy mareaIsProxyInstalled.
	] ensure: [ aProxy mareaUninstallIfNeeded].! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 4/5/2011 10:41'!
testMethodDictionaryForRecoveringProxiesAssociationsDo
	"| aProxy methodSize aProxy2 aProxy3 |
	
	methodSize := (ClassWith1Var >> #foo) size.
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	aProxy2 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo2.
	aProxy3 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo3.

	[ClassWith1Var methodDict associationsDo:  [:assoc | self deny: assoc value mareaIsProxy. ].
	
	self deny: aProxy mareaIsProxyInstalled. 
	self deny: aProxy mareaIsProxyInstalled. 
	self deny: aProxy mareaIsProxyInstalled. 
	] ensure: [ 
		aProxy mareaUninstallIfNeeded.
		aProxy2 mareaUninstallIfNeeded.
		aProxy3 mareaUninstallIfNeeded.
	].
"! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 4/5/2011 10:40'!
testMethodDictionaryForRecoveringProxiesAtIfAbsent
	"| aProxy methodSize aProxy2 aProxy3 |
	
	methodSize := (ClassWith1Var >> #foo) size.
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	aProxy2 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo2.
	aProxy3 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo3.
.
	[self deny: (ClassWith1Var methodDict at: #foo ifAbsent: []) mareaIsProxy.
	
	self deny: aProxy mareaIsProxyInstalled. 
	self assert: aProxy2 mareaIsProxyInstalled. 
	self assert: aProxy3 mareaIsProxyInstalled. 
	] ensure: [ 
		aProxy mareaUninstallIfNeeded.
		aProxy2 mareaUninstallIfNeeded.
		aProxy3 mareaUninstallIfNeeded.
	]."
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 4/5/2011 10:41'!
testMethodDictionaryForRecoveringProxiesValuesDo
	"| aProxy methodSize aProxy2 aProxy3 |
	
	methodSize := (ClassWith1Var >> #foo) size.
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	aProxy2 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo2.
	aProxy3 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo3.

	[ClassWith1Var methodDict valuesDo: [:method | self deny: method mareaIsProxy. ].
	
	self deny: aProxy mareaIsProxyInstalled. 
	self deny: aProxy mareaIsProxyInstalled. 
	self deny: aProxy mareaIsProxyInstalled. 
	] ensure: [ 
		aProxy mareaUninstallIfNeeded.
		aProxy2 mareaUninstallIfNeeded.
		aProxy3 mareaUninstallIfNeeded.
	].
"! !

!AbstractCompiledMethodProxyTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 11/30/2010 18:08'!
testSelector 
	^ testSelector ! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 4/1/2011 16:11'!
testSerializeCompiledMethod
	| method newMethod serializer |
method := ClassWith1Var >> #foo.
	"method := FormCanvas>> #transformBy:clippingTo:during:smoothing:.
	"
	"
method := (Refactoring class>>#initializeRefactoringOptions ).

method := RefactoryChangeManager class >> #settingsOn:.
"
	serializer := CompiledMethodProxySwapperHandler serializer. 
	
	"
	serializer := FuelMareaSerializer new.
	"
	
	serializer serializeAndWriteObject: method to: 'zaraza'.
	
	newMethod := serializer unserializeObjectFrom:  'zaraza'.

	self assert: method = newMethod.
	! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 11/30/2010 17:30'!
xtestCompiledMethodProxyWhenBothUnderstandSameMessage
	| aProxy methodSize |
	methodSize := (ClassWith1Var >> #foo) size.
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  self proxyClassName.
	self deny: (ClassWith1Var methodDict mareaAt: #foo) size = aProxy size. 
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  #CompiledMethod.
	self assert: (ClassWith1Var methodDict mareaAt: #foo) size = methodSize. 
	self assert: (ClassWith1Var methodDict mareaAt: #foo) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

AbstractCompiledMethodProxyTest subclass: #FilenameCompiledMethodProxySwapperFuelTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!FilenameCompiledMethodProxySwapperFuelTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/1/2011 16:07'!
setUp
	CompiledMethodProxySwapperHandler serializer: FuelMareaSerializer. 
	FilenameCompiledMethodProxySwapper runningTest: true.
	proxyClass := FilenameCompiledMethodProxySwapper.
	proxyInstance := FilenameCompiledMethodProxySwapper new! !

AbstractCompiledMethodProxyTest subclass: #FilenameCompiledMethodProxySwapperReferenceStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!FilenameCompiledMethodProxySwapperReferenceStreamTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/1/2011 16:07'!
setUp
	CompiledMethodProxySwapperHandler serializer: ReferenceStreamMareaSerializer. 
	FilenameCompiledMethodProxySwapper runningTest: true.
	proxyClass := FilenameCompiledMethodProxySwapper.
	proxyInstance := FilenameCompiledMethodProxySwapper new! !

AbstractCompiledMethodProxyTest subclass: #NumberAsFilenameCompiledMethodProxySwapperFuelTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!NumberAsFilenameCompiledMethodProxySwapperFuelTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/1/2011 16:07'!
setUp
	CompiledMethodProxySwapperHandler serializer: FuelMareaSerializer. 
	NumberAsFilenameCompiledMethodProxySwapper runningTest: true.
	proxyClass := NumberAsFilenameCompiledMethodProxySwapper.
	proxyInstance := NumberAsFilenameCompiledMethodProxySwapper new


! !

AbstractCompiledMethodProxyTest subclass: #NumberAsFilenameCompiledMethodProxySwapperReferenceStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!NumberAsFilenameCompiledMethodProxySwapperReferenceStreamTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/1/2011 16:07'!
setUp
	CompiledMethodProxySwapperHandler serializer: ReferenceStreamMareaSerializer. 
	NumberAsFilenameCompiledMethodProxySwapper runningTest: true.
	proxyClass := NumberAsFilenameCompiledMethodProxySwapper.
	proxyInstance := NumberAsFilenameCompiledMethodProxySwapper new


! !

TestCase subclass: #ClassProxySwapperTest
	instanceVariableNames: 'proxyClassName proxyClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!ClassProxySwapperTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/17/2011 15:18'!
installClassProxyOn: aClass
	^ self proxyClass installOn: aClass
! !

!ClassProxySwapperTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/5/2011 12:08'!
proxyClass
	^ proxyClass ! !

!ClassProxySwapperTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/5/2011 12:09'!
setUp
	proxyClass := ClassProxySwapper.
	proxyClassName := self proxyClass name.  
	(FileDirectory default fileNamesMatching: '*.swap*') 
		do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].
	self proxyClass runningTest: true.
! !

!ClassProxySwapperTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 3/31/2011 17:54'!
testClassSwapRestoreByClass
	"This is a more complex test with several asserts. The important thing in this test is that the original class is restored while sending a message directly to the class"
	
	| aProxy className |
	className := ClassWith1Var name.
	aProxy := self installClassProxyOn: ClassWith1Var.
	"after this is done, aProxy is pointing to ClassWith1Var"
	[self assert: (Smalltalk at: className) ==  ClassWith1Var.
	self assert: (Smalltalk at: className) mareaClass name equals: proxyClassName.
	self assert: (Smalltalk at: className) mareaIsProxyInstalled.
	"We are sure that the proxy was installed, now, lets uninstall it sending any message to the class"
	self assert: (Smalltalk at: className) fooClass equals: 'fooClass'.
	"Now lets check that the proxy was uninstalled"
	self assert: (Smalltalk at: className) mareaClass name equals: 'ClassWith1Var class'.
	self assert: (Smalltalk at: className) name equals: 'ClassWith1Var'.
	self deny: aProxy mareaIsProxyInstalled
	] ensure: [ aProxy mareaIsProxy ifTrue:  [ aProxy mareaUninstallIfNeeded]].
! !

!ClassProxySwapperTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 3/21/2011 20:51'!
testClassSwapRestoreByClassAndIsCompact

	| aProxy className |
	className := CompactClassMock name.
	self should: [self installClassProxyOn: CompactClassMock] raise: CannotProxifyCompactClasses  

! !

!ClassProxySwapperTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 3/31/2011 17:54'!
testClassSwapRestoreByClassAndNotUnderstood
	"This is a more complex test with several asserts. The important thing in this test is that the original class is restored while sending a message directly to the class"
	
	|  aProxy className |
	className := ClassWith1Var name.
	aProxy := self installClassProxyOn: ClassWith1Var.
	"after this is done, aProxy is pointing to ClassWith1Var"
	[self assert: (Smalltalk at: className) ==  ClassWith1Var.
	self assert: (Smalltalk at: className) mareaClass name equals: proxyClassName.
	self assert: (Smalltalk at: className) mareaIsProxyInstalled.
	"We are sure that the proxy was installed, now, lets uninstall it sending any message to the class"
	self should: [ (Smalltalk at: className) zaraza ] raise: Error.
	"Now lets check that the proxy was uninstalled"
	self assert: (Smalltalk at: className) mareaClass name equals: 'ClassWith1Var class'.
	self assert: (Smalltalk at: className) name equals: 'ClassWith1Var'.
	self deny: aProxy mareaIsProxyInstalled
	] ensure: [ aProxy mareaIsProxy ifTrue:  [ aProxy mareaUninstallIfNeeded]].
! !

!ClassProxySwapperTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 3/31/2011 17:54'!
testClassSwapRestoreByInstances
	"This is a more complex test with several asserts. The important thing in this test is that the original class is restored while sending a message to an instance of it."
	
	| inst aProxy className |
	inst := ClassWith1Var new.
	className := ClassWith1Var name.
	aProxy := self installClassProxyOn: ClassWith1Var.
	"after this is done, aProxy is pointing to ClassWith1Var"
	[self assert: (Smalltalk at: className) ==  ClassWith1Var.
	self assert: (Smalltalk at: className) mareaClass name equals: proxyClassName.
	self assert: (Smalltalk at: className) mareaIsProxyInstalled.
	"We are sure that the proxy was installed, now, lets uninstall it sending any message to the class"
	self assert: inst foo equals: 'foo'.
	"Now lets check that the proxy was uninstalled"
	self assert: (Smalltalk at: className) mareaClass name equals: 'ClassWith1Var class'.
	self assert: (Smalltalk at: className) name equals: 'ClassWith1Var'.
	self deny: aProxy mareaIsProxyInstalled
	] ensure: [ aProxy mareaIsProxy ifTrue:  [ aProxy mareaUninstallIfNeeded]].
! !

!ClassProxySwapperTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 3/21/2011 20:46'!
testClassSwapRestoreByInstancesAndClassIsCompact
	"With this test I want to demonstrate that we have a problem with compact classes. It doesn't work when having compact classes, since their instances, do not have a class pointer, and hence, the #become: doesn't update those pointers to point to my proxy. So....nothing to do."

	| inst aProxy className |
	inst := ClassWith1Var new.
	className := CompactClassMock name.
	self should: [self installClassProxyOn: CompactClassMock] raise: CannotProxifyCompactClasses.
	! !

!ClassProxySwapperTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 3/31/2011 17:54'!
testClassSwapRestoreByInstancesAndNotUnderstood
	"This is a more complex test with several asserts. The important thing in this test is that the original class is restored while sending a message to an instance of it."
	
	| inst aProxy className |
	inst := ClassWith1Var new.
	className := ClassWith1Var name.
	aProxy := self installClassProxyOn: ClassWith1Var.
	"after this is done, aProxy is pointing to ClassWith1Var"
	[self assert: (Smalltalk at: className) ==  ClassWith1Var.
	self assert: (Smalltalk at: className) mareaClass name equals: proxyClassName.
	self assert: (Smalltalk at: className) mareaIsProxyInstalled.
	"We are sure that the proxy was installed, now, lets uninstall it sending any message to the class"
	self should: [inst zaraza] raise: Error.
	"Now lets check that the proxy was uninstalled"
	self assert: (Smalltalk at: className) mareaClass name equals: 'ClassWith1Var class'.
	self assert: (Smalltalk at: className) name equals: 'ClassWith1Var'.
	self deny: aProxy mareaIsProxyInstalled
	] ensure: [ aProxy mareaIsProxy ifTrue:  [ aProxy mareaUninstallIfNeeded]].
! !

!ClassProxySwapperTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 3/31/2011 17:54'!
testClassSwapRestoreByInstancesAndUnderstoodByBoth
	"This is a more complex test with several asserts. The important thing in this test is that the original class is restored while sending a message to an instance of it."
	
	|  inst aProxy className |
	inst := ClassWith1Var new.
	className := ClassWith1Var name.
	aProxy := self installClassProxyOn: ClassWith1Var.
	"after this is done, aProxy is pointing to ClassWith1Var"
	[self assert: (Smalltalk at: className) ==  ClassWith1Var.
	self assert: (Smalltalk at: className) mareaClass name equals: proxyClassName.
	self assert: (Smalltalk at: className) mareaIsProxyInstalled.
	"We are sure that the proxy was installed, now, lets uninstall it sending any message to the class"
	 inst basicIdentityHash.
	 inst == Object new.
	"Notice that #basicIdentityHash  #==  ARE understood by both, the original object and the proxy, but in this case, the proxy IS uninstalled. Why?  because in this case, the uninstall happens because of the #cannotInterpret instead of the #doesNotUnderstand.  When using #cannotInterpret, we handle ANY message, not only the ones not understood. "
	self assert: (Smalltalk at: className) mareaClass name equals: 'ClassWith1Var class'.
	self assert: (Smalltalk at: className) name equals: 'ClassWith1Var'.
	self deny: aProxy mareaIsProxyInstalled.
	] ensure: [ aProxy mareaIsProxy ifTrue:  [ aProxy mareaUninstallIfNeeded]].

! !

!ClassProxySwapperTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/23/2011 15:44'!
testClassSwapSimple

	| inst aProxy |
	inst := ClassWith1Var new.
	aProxy := self installClassProxyOn: ClassWith1Var.
	[ self assert: (inst class == ClassWith1Var).
	self assert: inst foo = 'foo'.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

TestCase subclass: #MetaclassTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!MetaclassTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/5/2011 16:51'!
testMetaclassGC
	Transcript show: 'metaclases antes: ', Metaclass instanceCount  asString; cr.
	Smalltalk garbageCollect.
	ClassWith1Var become: ClassWith2Var new.
	Smalltalk garbageCollect.
	Transcript show: 'metaclases antes: ', Metaclass instanceCount  asString; cr.
	
	! !

TestCase subclass: #ObjectProxySwapperTest
	instanceVariableNames: 'proxyClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!ObjectProxySwapperTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/13/2011 18:38'!
installProxyOn: anObject. 
	^ self proxyClass installOn: anObject.! !

!ObjectProxySwapperTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 4/5/2011 12:09'!
proxyClass
	^ proxyClass! !

!ObjectProxySwapperTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 4/5/2011 12:09'!
setUp
	proxyClass := NumberAsFilenameObjectProxySwapper.
	(FileDirectory default fileNamesMatching: '*.swap*') 
		do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].
	self proxyClass runningTest: true.
	! !

!ObjectProxySwapperTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/13/2011 18:01'!
tearDown
"	(FileDirectory default fileNamesMatching: '*.swap') 
		do: [ :aFile | FileDirectory default deleteFileNamed: aFile ]."! !

!ObjectProxySwapperTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 12:32'!
testClassSelector
	| anObject |
	
	anObject := DateAndTime new.
	
	self installProxyOn: anObject. 
	
	[self assert: anObject mareaClass equals: self proxyClass.
	self assert: anObject mareaIsProxyInstalled.
	anObject class.
	anObject mareaClass.
	"all methos that start with marea are understood"
	self assert: anObject mareaIsProxyInstalled.
	
	self proxyClass runningTest: false.
	"since we are not running tests, #class should uninstall the proxy"
	anObject class.
	
	self assert: anObject class equals: DateAndTime.

	] ensure: [ anObject mareaIsProxy ifTrue:  [ anObject mareaUninstallIfNeeded]].

! !

!ObjectProxySwapperTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 17:16'!
testIdentity
	| anObject anotherPointer |
	
	anObject := DateAndTime new.
	anotherPointer := anObject.
	
	self installProxyOn: anObject. 
	
	[self assert: anObject mareaClass equals: self proxyClass..
	self assert: anObject mareaIsProxyInstalled.
	anObject mareaUninstallIfNeeded.
	self assert: anotherPointer == anObject.

	] ensure: [ anObject mareaIsProxy ifTrue:  [ anObject mareaUninstallIfNeeded]].

! !

!ObjectProxySwapperTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 12:31'!
testOneSingleObject
	| anObject |
	
	anObject := DateAndTime new.
	
	self installProxyOn: anObject. 
	
	[self assert: anObject mareaClass equals: self proxyClass.
	self assert: anObject mareaIsProxyInstalled.
	anObject name.
	self assert: anObject class equals: DateAndTime.

	] ensure: [ anObject mareaIsProxy ifTrue:  [ anObject mareaUninstallIfNeeded]].

! !

!ObjectProxySwapperTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 16:41'!
testOneSingleObjectProxyDNU

	| anObject |
	
	anObject := ClassWith1Var new.
	self installProxyOn: anObject. 
	[self assert: anObject class equals: self proxyClass.
	self assert: anObject mareaIsProxyInstalled.

	self should: [anObject zaraza] raise: MessageNotUnderstood.
	
	self assert: anObject class equals: ClassWith1Var.

	] ensure: [ anObject mareaIsProxy ifTrue:  [ anObject mareaUninstallIfNeeded]].
! !

!ObjectProxySwapperTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 12:31'!
testOneSingleObjectProxyUndetstandsDNU
	"The object that we swap does also understand the message doesNotUnderstand. We have to be sure not to loop and to correctly call both doesNotUnderstand:"
	| anObject |
	
	anObject := ClassWithDNU new.
	self installProxyOn: anObject. 
	[self assert: anObject class equals: self proxyClass.
	self assert: anObject mareaIsProxyInstalled.
	self assert: anObject zaraza equals: 'dnu'.
	self assert: anObject class equals: ClassWithDNU.

	] ensure: [ anObject mareaIsProxy ifTrue:  [ anObject mareaUninstallIfNeeded]].
! !

TestCase subclass: #ObjectProxyTracerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!ObjectProxyTracerTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 16:12'!
installProxyOn: anObject. 
	^ self proxyClass installOn: anObject withHandler: ObjectProxyTracerHandler.! !

!ObjectProxyTracerTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 16:12'!
proxyClass
	^ ObjectProxyWithTarget! !

!ObjectProxyTracerTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 16:12'!
setUp

	self proxyClass runningTest: true.
	! !

!ObjectProxyTracerTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 16:57'!
testClassSelector
	| anObject proxy |
	
	anObject := DateAndTime new.
	
	proxy := self installProxyOn: anObject. 
	
	[self assert: proxy mareaClass equals: self proxyClass.
	self assert: proxy class equals: self proxyClass.
	self assert: proxy mareaIsProxyInstalled.
	"all methos that start with marea are understood. And #class too"
	self assert: proxy mareaIsProxyInstalled.
	
	self proxyClass runningTest: false.
	self assert: proxy class equals: DateAndTime.
	self assert: proxy mareaClass equals: self proxyClass.
	
	proxy mareaUninstallIfNeeded.
	self assert: proxy class equals: self proxyClass.
	self assert: proxy mareaClass equals: self proxyClass.
	
	] ensure: [ proxy mareaUninstallIfNeeded].

! !

!ObjectProxyTracerTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 17:19'!
testIdentity
	| anObject proxy |
	
	anObject := DateAndTime new.
	
	proxy := self installProxyOn: anObject. 
	
	[self assert: proxy mareaClass equals: self proxyClass..
	self assert: proxy mareaIsProxyInstalled.
	self deny: proxy == anObject.
	proxy mareaUninstallIfNeeded.
	self deny: proxy == anObject.

	] ensure: [ anObject mareaIsProxy ifTrue:  [ anObject mareaUninstallIfNeeded]].

! !

!ObjectProxyTracerTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 19:01'!
testOneSingleObject
	| anObject aProxy |
	
	anObject := 'jejejejej'.
	
	aProxy := self installProxyOn: anObject. 
	
	[self assert: aProxy mareaClass equals: self proxyClass.
	self assert: aProxy mareaIsProxyInstalled.
	self assert: (aProxy includesSubString: 'jeje').
	self assert: aProxy= anObject.
	aProxy mareaUninstallIfNeeded.
	self deny: aProxy mareaIsProxyInstalled.
	self deny: aProxy = anObject.
	self should: [aProxy includesSubString: 'jeje'] raise: MessageNotUnderstood.
	] ensure: [ aProxy mareaUninstallIfNeeded].

! !

!ObjectProxyTracerTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 16:43'!
testOneSingleObjectProxyDNU

	| anObject proxy |
	
	anObject := ClassWith1Var new.
	proxy := self installProxyOn: anObject. 
	[self assert: proxy class equals: self proxyClass.
	self assert: proxy mareaIsProxyInstalled.
	
	self should: [proxy zaraza] raise: MessageNotUnderstood.
	

	] ensure: [ proxy mareaUninstallIfNeeded].
! !

!ObjectProxyTracerTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 3/30/2011 16:45'!
testOneSingleObjectProxyUndetstandsDNU
	"The object that we swap does also understand the message doesNotUnderstand. We have to be sure not to loop and to correctly call both doesNotUnderstand:"
	| anObject proxy |
	
	anObject := ClassWithDNU new.
	proxy := self installProxyOn: anObject. 
	
	[self assert: proxy class equals: self proxyClass.
	self assert: proxy mareaIsProxyInstalled.
	self assert: proxy zaraza equals: 'dnu'.
	
	] ensure: [ proxy mareaUninstallIfNeeded].
! !

!ReferenceStreamMareaSerializer methodsFor: '*ProxiesTests' stamp: 'MarianoMartinezPeck 11/24/2010 23:29'!
internalMethodForTesting
	^ ReferenceStream methodDict at: #next.! !

!TestSuite methodsFor: '*ProxiesTests' stamp: 'MarianoMartinezPeck 11/30/2010 18:07'!
tests: aCollectionOfTests
	tests := aCollectionOfTests 
			! !

!FuelMareaSerializer methodsFor: '*ProxiesTests' stamp: 'MarianoMartinezPeck 11/24/2010 23:38'!
internalMethodForTesting
	^ FLMaterializer methodDict at: #materialize! !
